`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/20/2018 05:00:53 PM
// Design Name: 
// Module Name: distance_to_LED_mux
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module distance_to_LED_mux(
    input [2:0] switches, //SW7,SW6,SW5
    input push_btn,  //BTNR
    input [15:0]    segment_7,//MSB byte = Distance MSB byte, LSB byte = Segment #
                    segment_6,
                    segment_5,
                    segment_4,
                    segment_3,
                    segment_2,
                    segment_1,
                    segment_0,
                    
    output [7:0] LEDs // LED0-7
    );
    
    //for push button selection 
    parameter distance_byte = 1'b0, //e.g. segment_7 [15:8]
              segment_byte = 1'b1; //e.g. segment_7 [7:0]
    
    //for selecting data 
    parameter [2:0] seg_0 = 3'b0,
                    seg_1 = 3'b1,
                    seg_2 = 3'b010,
                    seg_3 = 3'b011,
                    seg_4 = 3'b100,
                    seg_5 = 3'b101,
                    seg_6 = 3'b110,
                    seg_7 = 3'b111;
                    
    reg [7:0] distance,
              seg_num;
              
              
    always @ (switches, segment_7, segment_6, segment_5, segment_4, segment_3, segment_2, segment_1, segment_0)
    case(switches)
                seg_0: begin
                    distance = segment_0[15:8];
                    seg_num = segment_0[7:0];
                end
                
                seg_1: begin
                    distance = segment_1[15:8];
                    seg_num = segment_1[7:0];
                end
                
                seg_2: begin
                    distance = segment_2[15:8];
                    seg_num = segment_2[7:0];
                end
                
                seg_3: begin
                    distance = segment_3[15:8];
                    seg_num = segment_3[7:0];
                end
                
                seg_4: begin
                    distance = segment_4[15:8];
                    seg_num = segment_4[7:0];
                end
                
                seg_5: begin
                    distance = segment_5[15:8];
                    seg_num = segment_5[7:0];
                end
                
                seg_6: begin
                    distance = segment_6[15:8];
                    seg_num = segment_6[7:0];
                end
                
                seg_7: begin
                    distance = segment_7[15:8];
                    seg_num = segment_7[7:0];
                end
                
            endcase
            
     assign LEDs = (push_btn) ? seg_num : distance;
     
endmodule
