`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: Worcester Polytechnic Institute
// Engineer: Kazim Shaikh
// Edited by: Dario Martinovic
// 
// Create Date: 01/21/2018
// Module Name: tone_generator
//
// Description: Module to generate sound output on buzzer when critical action
//              should be taken.  Person in critical action zone.
// 
//////////////////////////////////////////////////////////////////////////////////

module tone_generator(  
    input clk,  //clock input
    input [21:0] counter,   //count signal
    output reg sound    //output sound
    );

    wire sound_next;
    wire sound_invert;
    
    reg [21:0] num;
    wire [21:0] next_num;
    
    always@(posedge clk) begin
        if(num == counter)
        begin
            sound <= sound_invert;
            num <= 22'd0;
        end
        else
        begin
            sound <= sound_next;
            num <= next_num;
        end
    end
    
    assign next_num = num + 22'b1;
    assign sound_next = sound;
    assign sound_invert = ~sound;
    
endmodule
